; RSS reader.
; by blackhorus (rss_reader@yahoo.fr )
; v 0.3 
;   Resolved the the same ID for two differet URL.
;   Add some missing function for the hash table.
;   Replace my httpget routine with Tomalak's one.
;
; v 0.2 added a config dialog
; v 0.1 First realese
;
; Thanks goes to :
; sais,argv[0],Pingu` from mirc channel
; tomalak for his httpget script and help


var %url

dialog RssDialogConfigAdd {
  size -1 -1 276 124
  title "Add..."
  text "ID:",1,40 13 15 13
  text "URL:",2,32 34 23 13
  edit "",3,79 10 187 25
  edit "",4,79 37 187 49, hsbar multi
  button "&OK",5,140 91 60 22, ok
  button "&Close",6,205 91 60 22, cancel
}

on *:dialog:RssDialogConfigAdd:sclick:5: {
  %var1 = $did(RssDialogConfigAdd,3)
  %var2 = $did(RssDialogConfigAdd,4)

  ; the user must supply values...
  if ((!%var1) || (!%var2))  {
    %t = $input(You must supply values !!!,oh,Error)
    halt
  }
  ; check if this ID still exist in our hash table.
  %result = $hget(IDUrl, %var1)
  if (%result) {
    %t = $input(ID %var1 always exist !!!,oh,Error)
    halt
  }

  did -a  RssDialogConfig 1 + 0 0 0 %var1 $+ $chr(9) $+ + 0 0 0 %var2 
  .hadd -m IDUrl %var1 %var2
}

dialog RssDialogConfig {
  size -1 -1 361 226
  title "Add Rss Url"
  list 1,10 14 332 166,vsbar size
  button "&Add",2,100 191 57 25
  button "&Update",3,224 191 57 25
  button "&Remove",4,157 191 57 25
  button "&Close",5,283 191 57 25, ok
}

on *:dialog:RssDialogConfig:sclick:3: {
  ; create another empty file by erasing the older one.
  .remove $+(",$scriptdir,url.ini,")
  %lines = $did(RssDialogConfig,1).lines 

  %iLoop = 1
  while (%iLoop < %lines) {
    writeini $+(",$scriptdir,url.ini,") urls $ldid(RssDialogConfig,1,1,%iLoop) $ldid(RssDialogConfig,1,2,%iLoop)
    inc %iLoop
  }
}

on *:dialog:RssDialogConfig:sclick:2: {
  dialog -m RssDialogConfigAdd RssDialogConfigAdd
}

on *:dialog:RssDialogConfig:sclick:4: {
  %result = $input(Are you sure to remove this item ?,yw,Warning)
  if (%result == $true) {
    ; remove it from the listview.
    hdel IDUrl $cell(RssDialogConfig,1,$did(1).sel,1)
    ; remove it from the listview.
    did -d RssDialogConfig 1 $did(1).sel
  }
}

on *:dialog:RssDialogConfig:init:*:{
  mdx SetMircVersion $version
  mdx MarkDialog $dname

  mdx SetControlMDX $dname 1 ListView editlabels report rowselect showsel grid single labeltip headerdrag flatsb  >  $scriptdir $+ views.mdx

  did -i $dname 1 1 headerdims 70 243
  did -i $dname 1 1 headertext ID $chr(9) URL

  ;--------- retrieve the url and their id from the ini file.
  ; number of lines under the first section which is [url id]
  %lines = $ini($+(",$scriptdir,url.ini,"),1,0) 

  ;setup the listview control and the hash table.
  .hfree -ws IDUrl
  .hmake -s IDUrl 50

  %iLoop = 1
  while (%iLoop <= %lines) {
    %col1 = $ini($+(",$scriptdir,url.ini,"),1,%iLoop)
    %col2 = $readini($+(",$scriptdir,url.ini,"),urls,%col1)

    did -a  RssDialogConfig 1 + 0 0 0 %col1 $+ $chr(9) $+ + 0 0 0 %col2
    .hadd -sm IDUrl %col1 %col2

    inc %iLoop
  }
}

alias Rss.config {
  dialog -m RssDialogConfig RssDialogConfig
}

alias Rss.Read {

  if (!$1-) {
    echo -a Missing ID Rss Adress ...
    return
  }

  %url = $hget(IDUrl, $1-)
  if (!%url) {
    echo -a No Url associated with this ID.
    return
  }
  httpget %url $1-
}



alias mdx {
  var %dll = $scriptdir $+ mdx.dll
  return $dll(%dll,$1,$2-)
}

;----------------------------------------------------------------------------
; The XML processing
;----------------------------------------------------------------------------

alias Rss.show {

  if (!$1-) {
    echo -a Missing RSS ID  ...
    return
  }

  ; dll and .xml files
  var %dll = $+(",$scriptdir,xml.dll,")
  var %xml = $+(",$scriptdir,$1,")

  if (!$isfile(%dll)) { echo -a Error - missing: %dll | return }
  if (!$isfile(%xml)) { echo -a Error - missing: %xml | return }

  ; parser name
  var %n = Rss

  var %a = $dll(%dll,create_parser,%n)
  if (%a != S_OK) { echo -a Error - create_parser: %a | return }

  dll %dll set_handler_chardata %n hchardata


  echo -a Setting XML file : %xml
  dll %dll set_file %n %xml

  ; global var: dll pathname will be use in start and end element handlers
  %xmldemo.dll = %dll

  ;echo $color(join) -a Parsing :

  var %a = $dll(%dll,parse_file,%n)
  if (%a != S_OK) { echo -a Error - parse_file: %a }

  ;echo -a Deleting parser %n
  dll %dll free_parser %n

  ; unsets global var
  unset %xmldemo.*

}

alias hchardata {
  ; The Channel
  if ( $dll(%xmldemo.dll,get_abspath,$1) == rss/channel/title ) {
    echo -a $chr(31) $+ Channel Title $+ $chr(31) : $2-
  }
  if ( $dll(%xmldemo.dll,get_abspath,$1) == rss/channel/description ) {
    echo -a $chr(31) $+ Channel Description $+ $chr(31) : $2-
  }
  ; item
  if ( $dll(%xmldemo.dll,get_abspath,$1) == rss/channel/item/title ) {
    echo -a $chr(2)
    echo -a $chr(31) $+ Title $+ $chr(31): $2-
  }
  if ( $dll(%xmldemo.dll,get_abspath,$1) == rss/channel/item/description ) {
    echo -ai $chr(31) $+  Description $+ $chr(31) : $2-
  }
  if ( $dll(%xmldemo.dll,get_abspath,$1) == rss/channel/item/link ) {
    echo -a $chr(2) $2- $chr(2)
  }
  ; uncomment this one if u would some more information
  ;if ( $dll(%xmldemo.dll,get_abspath,$1) == rss/channel/item/Author ) {
  ;  echo -a Article author : $2-
  ;}
  ;if ( $dll(%xmldemo.dll,get_abspath,$1) == rss/channel/item/pubdate ) {
  ;  echo -a Article date : $2-
  ;}

}
; Usage:
; $cell(Dialog name,ID,Line,Cell)
; Contact:
;	IRC: Gallagher @ PTnet
;	E-mail: morphy_chaos@hotmail.com
;	Website: www.chaos.page.vu

alias cell {
  return $gettok($gettok($gettok($did($1,$2,$3),$4,9),$iif($4 = 1,6,5) $+ -,32),1,4)
}

; $ldid(Dialog,ID,N) de l3z4rD
alias ldid {
  var %line = $iif($4 isnum,$calc($4 +1),$did($1,$2).sel)) , %did = $did($1,$2,%line)
  if ($prop == total) return $numtok(%did,9)
  return $gettok($gettok(%did,$3,9),$iif($3 == 1,6-,5-),32)
}

; -----------------------------------------------------------------------------------
;HTTP Transfer Script
;beta phase!
;
;Original script: Tomalak Geret'kal from www.deep-space-5.org/mirchelp.php";
;Usage: /httpget http://<host>/<path> [local_folder]
;
;-------------------------------------------------------------------------------------*/

alias httpget {
  if ($regex($1,/^http:\/\/([^\/]+)(\/.+)$/i)) {
    echo -a [HTTP] Opening to  $+ $regml(1) $+  on port: 80

    var %name = httpget_socket

    sockopen %name $regml(1) 80
    set % $+ %name $+ .url $regml(1)
    set % $+ %name $+ .path $regml(2)

    var %2 = $2
    set % $+ %name $+ .saveto %2
  }
}

on *:sockopen:httpget_socket:{
  echo -a  Connection established

  var %request1 = GET % [ $+ [ $sockname ] $+ .path ] HTTP/1.1
  var %request2 = Host: % [ $+ [ $sockname ] $+ .url ]
  var %request3 =  % [ $+ [ $sockname ] $+ .url ] close
  sockwrite -t $sockname %request1 $+ $crlf $+ %request2 $+ $crlf $+ Connection: close  $+ $crlf $+ $crlf
  echo -a  Request sent...
}

on *:sockwrite:httpget_socket:{
  if ($sockerr) echo -a  Error: $ifmatch
}

on *:sockread:httpget_socket:{
  if ($sockerr > 0) return
  var %fname = $+(",$scriptdir,%httpget_socket.saveto,")


  :nextread

  if (!$sock($sockname).mark) {
    sockread %output

    if ($sockbr == 0) {
      sockclose $sockname
      return
    }

    var %400 = HTTP/1.1 400 Bad Request
    var %404 = HTTP/1.1 404 Not Found

    if (%400 iswm %output) {
      echo -a 4 Bad HTTP Request
      sockclose $sockname
    }
    elseif (%404 iswm %output) {
      echo -a  File Not Found!
      sockclose $sockname
    }
    elseif ($regex(%output,/HTTP\/1.1 (4|5\d\d) (.+)/)) {
      echo -a  ERROR $regml(1) $+ : $regml(2)
      sockclose $sockname
    }

    if (%output == $null) {
      sockmark $sockname header received
      write -c %fname 

    }
  }
  else {
    sockread -nf 4096 &output

    if ($sockbr == 0) {
      return
    }

    bwrite %fname -1 -1 &output
  }

  goto nextread
}

on *:sockclose:httpget_socket:{
  echo -a  Transfer complete. File saved as 12 $+ %httpget_socket.saveto $+ 
  echo -a  Connection closed
  .unset % $+ $sockname $+ .*
}
